<bugID>1150859<Summary>Remove preprocessor directives from browser code</Summary><Description>Preprocessor directive in Javascript and CSS code to include and/ or exclude code from a firefox build creates the following list of - non exhaustive - problems:

 - In JS, stack traces often do not match the actual line numbers, which adds a manual extra step to backtrace where the code is actually hit.
 - A build step is necessary to apply changes made in the source code.
 - The previous point also means that a developer needs to memorize for which part of the browser she/ he is working on a (re-)build is necessary.
 - A build step slows down fast (re-)iterative development and rapid prototyping.

Wherever possible we should be trying minimize or even eliminate the use of `#include` and `#ifdef` preprocessors throughout the 'browser/' sub-tree.

'Plan de campagne' as it currently stands:
 - Write a static analysis tool in JS, running on XPCShell to read, parse and analyze the browser JS source files. It will operate in three phases:
    1) List &amp; count the current scope of use of preprocessor directives
    2) For source files that are #include'd, list &amp; count the number of implicit global variables
    3) Track the numbers over time.
 - Depending on practical feasibility, write a source refactor tool in JS, running on XPCShell to use the data produced by aforementioned script to apply (minor) code modifications that are verifiable correct.
 - Hook the analysis script to automation as a pre-receive hook in Mercurial, to prevent adding more preprocessor dependent code. It is possible to use another hook - the earlier we can run the script the better - but for that to know we'd like to request gps' help.
 - Spin off bugs based on the initial results of the analysis script; the intention is to slowly iterate towards moving all #include'd files to be JS modules that are retrieved lazily by browser.js. The #ifdef removal is second priority.

djc and mikedeboer are working on the analysis script - based on Reflect.parse - which will be the cornerstone of this endeavor. The bugs that will be filed based on the results it yields will be filed blocking this (meta) bug.</Description></bugID>